property pDataMember, pQuestionNum, pPossiblePoints, pScore, pCorrectAnswer, pCorrectSound, pWrongSound, pEndGameFrame, pAlreadyUsedList

on getPropertyDescriptionList me
  list = [:]
  addProp(list, #pDataMember, [#comment: "Data Member", #format: #text, #default: VOID])
  addProp(list, #pCorrectSound, [#comment: "Correct Sound", #format: #string, #default: EMPTY])
  addProp(list, #pWrongSound, [#comment: "Wrong Sound", #format: #string, #default: EMPTY])
  addProp(list, #pEndGameFrame, [#comment: "End Game Frame", #format: #marker, #default: #next])
  return list
end

on beginSprite me
  pQuestionNum = 1
  pScore = 0
  showScore(me)
  pAlreadyUsedList = []
  askQuestion(me)
end

on askQuestion me
  repeat while 1
    r = random(pDataMember.text.line.count)
    if not getOne(pAlreadyUsedList, r) then
      exit repeat
    end if
  end repeat
  add(pAlreadyUsedList, r)
  text = pDataMember.text.line[r]
  sendAllSprites(#makeVisible)
  the itemDelimiter = ";"
  question = text.item[1]
  answers = text.item[2]
  pCorrectAnswer = value(text.item[3])
  member("Question").text = question
  the itemDelimiter = ","
  repeat with i = 1 to 4
    member("Answer" && i).text = answers.item[i]
  end repeat
  pPossiblePoints = 1000
  showPossiblePoints(me)
end

on showPossiblePoints me
  if pPossiblePoints < 0 then
    pPossiblePoints = 0
  end if
  member("Possible Points").text = ":" && pPossiblePoints
end

on showScore me
  member("Score").text = ":" && pScore
end

on clickAnswer me, n
  if n = pCorrectAnswer then
    if pCorrectSound <> EMPTY then
      puppetSound(pCorrectSound)
    end if
    pScore = pScore + pPossiblePoints
    showScore(me)
    nextQuestion(me)
    return 1
  else
    if pWrongSound <> EMPTY then
      puppetSound(pWrongSound)
    end if
    pPossiblePoints = pPossiblePoints - 100
    showPossiblePoints(me)
    return 0
  end if
end

on nextQuestion me
  pQuestionNum = pQuestionNum + 1
  if pQuestionNum > pDataMember.text.line.count then
    if pScore >= 5000 then
      go("hiscore")
    else
      go(pEndGameFrame)
    end if
  else
    askQuestion(me)
  end if
end

on exitFrame me
  pPossiblePoints = pPossiblePoints - 1
  showPossiblePoints(me)
  go(the frame)
end

on keyDown me
  sendAllSprites(#keyHit, the key)
end
